"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PredicateFormulaEditorContext = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
/* eslint-disable @typescript-eslint/no-empty-function */
/* eslint-disable react/require-default-props */
var react_1 = __importStar(require("react"));
var gabby_query_protocol_lib_1 = require("gabby-query-protocol-lib");
var defaultOpLabels_1 = require("../defaultOpLabels");
var Context = react_1.default.createContext(null);
var noop = function () { };
var ContextProvider = function (_a) {
    //
    //  const setQueryExpression = (param: unknown) => {};
    var children = _a.children, _b = _a.onChange, onChange = _b === void 0 ? noop : _b, _c = _a.operatorLabels, operatorLabels = _c === void 0 ? defaultOpLabels_1.defaultOperatorLabels : _c, predicateFormulaEditor = _a.predicateFormulaEditor;
    var _d = (0, react_1.useState)(
    // useState to make dependents 'aware' of change.
    // change/state is managed by predicateFormulaEditor
    //    predicateFormulaEditor.toJson().predicateTreeJson || {}
    predicateFormulaEditor.toJson().predicateTreeJson), queryExpression = _d[0], setQueryExpression = _d[1];
    var updateState = function (newState) {
        onChange(newState); // pretty sure this is for debug only
        setQueryExpression(newState);
    };
    var appendPredicate = function (parentNodeId, term
    // term: TPredicateProperties | TPredicatePropertiesArrayValue
    ) {
        var parentNode = predicateFormulaEditor.predicateTree.getPredicateById(parentNodeId);
        // this is a band-aid to get around the fact that the predicateFormulaEditor
        // appends to non-existing nodes
        // https://github.com/terary/gabby-query-protocol-lib/issues/34
        // issues has been resolved.  Leaving band-aid until such time revision can be tested
        if (parentNode === null) {
            throw Error("parentNodeId not found");
        }
        var newPredicateId = predicateFormulaEditor.predicatesAppend(parentNodeId, term);
        updateState(__assign({}, predicateFormulaEditor.toJson().predicateTreeJson));
        return newPredicateId;
    };
    var makeEmptyPredicate = function () {
        return predicateFormulaEditor.makeEmptyPredicate();
    };
    var isBranchNode = function (predicateId) {
        return predicateFormulaEditor.predicateTree.isBranch(predicateId);
    };
    var getLeafIdsAll = function () {
        var leafVisitor = new gabby_query_protocol_lib_1.TreeVisitors.PredicateIdsLeafs();
        predicateFormulaEditor.predicateTree.acceptVisitor(leafVisitor);
        return leafVisitor.predicateIds;
        //    return leafVisitor.predicateIds || [];
    };
    // const getRootId = () => {
    //   return predicateFormulaEditor.rootNodeId;
    // };
    var getPredicateLeafById = function (predicateId) {
        return predicateFormulaEditor.predicatesGetPropertiesById(predicateId);
    };
    var getPredicateById = function (nodeId) {
        return predicateFormulaEditor.predicatesGetById(nodeId);
    };
    var getJunctionById = function (nodeId) {
        //  does throw
        return predicateFormulaEditor.predicatesGetJunctionById(nodeId);
    };
    var getPredicateTreeAsJson = function () {
        return predicateFormulaEditor.toJson().predicateTreeJson;
    };
    var isRoot = function (predicateId) {
        return predicateId === predicateFormulaEditor.rootNodeId;
    };
    var updatePredicate = function (predicateId, predicate) {
        var _a = gabby_query_protocol_lib_1.Validators.ValidatePredicateAgainstOperator(predicate, predicateFormulaEditor.subjectDictionary), hasError = _a.hasError, errorMessages = _a.errorMessages;
        if (hasError) {
            throw Error("Failed to update Predicate. Data validation error");
        }
        predicateFormulaEditor.predicatesReplace(predicateId, predicate);
        updateState(__assign({}, predicateFormulaEditor.toJson().predicateTreeJson));
    };
    var removePredicate = function (nodeId) {
        predicateFormulaEditor.predicatesRemove(nodeId);
        updateState(__assign({}, predicateFormulaEditor.toJson().predicateTreeJson));
    };
    var setDisjunction = function (predicateId) {
        predicateFormulaEditor.predicatesReplace(predicateId, {
            operator: "$or",
        });
        updateState(__assign({}, predicateFormulaEditor.toJson().predicateTreeJson));
    };
    var setConjunction = function (predicateId) {
        predicateFormulaEditor.predicatesReplace(predicateId, {
            operator: "$and",
        });
        updateState(__assign({}, predicateFormulaEditor.toJson().predicateTreeJson));
    };
    var getChildrenIds = function (predicateId) {
        var debugC = predicateFormulaEditor.predicatesGetChildrenIds(predicateId);
        return isBranchNode(predicateId)
            ? predicateFormulaEditor.predicatesGetChildrenIds(predicateId)
            : [];
    };
    var exportedProperties = {
        appendPredicate: appendPredicate,
        getChildrenIds: getChildrenIds,
        getJunctionById: getJunctionById,
        getLeafIdsAll: getLeafIdsAll,
        getPredicateById: getPredicateById,
        getPredicateLeafById: getPredicateLeafById,
        getPredicateTreeAsJson: getPredicateTreeAsJson,
        makeEmptyPredicate: makeEmptyPredicate,
        isBranchNode: isBranchNode,
        isRoot: isRoot,
        operatorLabels: operatorLabels,
        removePredicate: removePredicate,
        setConjunction: setConjunction,
        setDisjunction: setDisjunction,
        subjectDictionary: predicateFormulaEditor.subjectDictionary,
        updatePredicate: updatePredicate,
    };
    return (0, jsx_runtime_1.jsx)(Context.Provider, __assign({ value: exportedProperties }, { children: children }), void 0);
};
var PredicateFormulaEditorContext = {
    context: Context,
    // provider: ContextProvider,
    Provider: ContextProvider,
};
exports.PredicateFormulaEditorContext = PredicateFormulaEditorContext;
//# sourceMappingURL=Provider.js.map