"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useJunctionProperties = void 0;
/* eslint-disable import/prefer-default-export */
var react_1 = __importDefault(require("react"));
var context_1 = require("../context");
var useJunctionProperties = function (predicateId) {
    var _a = react_1.default.useContext(context_1.PredicateFormulaEditorContext.context), appendPredicate = _a.appendPredicate, getChildrenIds = _a.getChildrenIds, getJunctionById = _a.getJunctionById, getPredicateById = _a.getPredicateById, isBranchNode = _a.isBranchNode, isRoot = _a.isRoot, removePredicate = _a.removePredicate, setNodeConjunction = _a.setConjunction, setNodeDisjunction = _a.setDisjunction;
    if (!isBranchNode(predicateId)) {
        throw new Error("Tried useJunctionProperties on non junction/branch node");
    }
    return {
        appendPredicate: function (newPredicate) {
            return appendPredicate(predicateId, newPredicate);
        },
        getChildrenIds: function () {
            return getChildrenIds(predicateId);
        },
        getChildIdsOf: function (predicateId) {
            return getChildrenIds(predicateId);
        },
        getJunctionProperties: function () {
            // does throw
            return getJunctionById(predicateId);
        },
        getPredicateById: getPredicateById,
        isBranchNode: isBranchNode(predicateId),
        isRoot: isRoot(predicateId),
        removeCurrentPredicateJunction: function () {
            removePredicate(predicateId);
        },
        setConjunction: function () {
            setNodeConjunction(predicateId);
        },
        setDisjunction: function () {
            setNodeDisjunction(predicateId);
        },
    };
};
exports.useJunctionProperties = useJunctionProperties;
//# sourceMappingURL=useJunctionProperties.js.map