import type { TPredicateNode, TValidatorResponse, TPredicateSubjectWithId } from "gabby-query-protocol-lib";
import { TPredicatePropertiesGeneric } from "../type";
export interface IUsePredicateProperties {
    appendPredicate: (newPredicate: TPredicatePropertiesGeneric) => string;
    getPredicateById: (predicateId: string) => TPredicateNode | null;
    getPredicateLeafProperties: () => {
        predicateProperties: TPredicatePropertiesGeneric;
        subjectProperties: TPredicateSubjectWithId;
    };
    isRoot: boolean;
    removeCurrentPredicate: () => void;
    updateCurrentPredicate: (changes: TPredicatePropertiesGeneric) => void;
    validatePredicateProperties: (predicateProperties: TPredicatePropertiesGeneric) => TValidatorResponse;
}
export declare const usePredicateProperties: (predicateId: string) => IUsePredicateProperties;
