"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.usePredicateProperties = void 0;
/* eslint-disable import/prefer-default-export */
var react_1 = __importDefault(require("react"));
var gabby_query_protocol_lib_1 = require("gabby-query-protocol-lib");
var context_1 = require("../context");
var usePredicateProperties = function (predicateId) {
    var _a = react_1.default.useContext(context_1.PredicateFormulaEditorContext.context), appendPredicate = _a.appendPredicate, getPredicateById = _a.getPredicateById, getPredicateLeafById = _a.getPredicateLeafById, isRoot = _a.isRoot, removePredicate = _a.removePredicate, updatePredicate = _a.updatePredicate, subjectDictionary = _a.subjectDictionary;
    return {
        appendPredicate: function (newPredicate) {
            return appendPredicate(predicateId, newPredicate);
        },
        getPredicateLeafProperties: function () {
            var predicateProperties = getPredicateLeafById(predicateId);
            var subjectProperties = subjectDictionary.getSubject(predicateProperties.subjectId);
            return { predicateProperties: predicateProperties, subjectProperties: subjectProperties };
        },
        getPredicateById: getPredicateById,
        isRoot: isRoot(predicateId),
        removeCurrentPredicate: function () {
            removePredicate(predicateId);
        },
        updateCurrentPredicate: function (changes) {
            updatePredicate(predicateId, changes);
        },
        validatePredicateProperties: function (predicateProperties) {
            return gabby_query_protocol_lib_1.Validators.ValidatePredicateAgainstOperator(predicateProperties, subjectDictionary);
        },
    };
};
exports.usePredicateProperties = usePredicateProperties;
//# sourceMappingURL=usePredicateProperties.js.map