import type { TPredicateOperatorLabels } from "../type";
import type { IPredicateSubjectDictionary, TPredicateOperator, TPredicateProperties, TPredicatePropertiesArrayValue, TSerializedPredicateTree, TPredicateSubjectWithId, TValueLabelList } from "gabby-query-protocol-lib";
export interface IUsePredicateTreeUtilities {
    getChildrenIds: (predicateId: string) => string[];
    getPredicateTreeAsJson: () => TSerializedPredicateTree;
    getSubjectById: (subjectId: string) => TPredicateSubjectWithId;
    operatorLabels: TPredicateOperatorLabels;
    subjectDictionary: IPredicateSubjectDictionary;
    testIsBranchNode: (predicateId: string) => boolean;
    getSelectOptions: (subjectId: string, operator: TPredicateOperator) => TValueLabelList;
    makeEmptyPredicate: () => TPredicateProperties | TPredicatePropertiesArrayValue;
}
export declare const usePredicateTreeUtilities: () => IUsePredicateTreeUtilities;
