"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProjectionContext = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
/* eslint-disable @typescript-eslint/no-empty-function */
/* eslint-disable import/no-extraneous-dependencies */
/* eslint-disable react/require-default-props */
var React = __importStar(require("react"));
var Context = React.createContext(null);
var ContextProvider = function (_a) {
    //
    var children = _a.children, 
    //  onChange = noop,
    projectionEditor = _a.projectionEditor;
    var _b = React.useState(projectionEditor.getProjectionOrderByColumPosition()), currentProjection = _b[0], setCurrentProjection = _b[1];
    // private (not exported)
    var updateProjectionState = function () {
        setCurrentProjection(projectionEditor.getProjectionOrderByColumPosition());
    };
    // **************************************     projection
    var addProjectionItem = function (projectionSubject) {
        // TODO - tmc - I think keys will change I think the getByOrder...
        //        rekeys? the keys should remain the same but this will return {newKey:{sameKey:properties}}
        //        ** MAYBE, I THINK **
        var newProjectionKey = projectionEditor.addSubject(projectionSubject);
        updateProjectionState();
        return newProjectionKey;
    };
    var getProjectionItem = function (projectionKey) {
        return projectionEditor.getProjectionSubject(projectionKey);
    };
    var getOrderedProjectionList = function () {
        return projectionEditor.getProjectionOrderByColumPosition();
    };
    var removeProjectionItem = function (projectionKey) {
        projectionEditor.removeProjectionSubject(projectionKey);
        updateProjectionState();
    };
    var makeDefaultProjectionItem = function () {
        var subjectDictionary = projectionEditor.getProjectableSubjectsDictionary();
        var justSomeSubjectId = subjectDictionary.getSubjectIds().shift();
        if (!justSomeSubjectId) {
            throw new Error("Found no subject id in Subject Dictionary");
        }
        var justSomeSubject = subjectDictionary.getSubjectById(justSomeSubjectId);
        // I dont think this is possible
        // if (!justSomeSubject) {
        //   throw new Error("Found no subjects in Subject Dictionary");
        // }
        return {
            subjectId: justSomeSubjectId,
            label: justSomeSubject.defaultLabel,
            columnOrder: 0,
            sortOrder: 0,
        };
    };
    var updateProjectionSubject = function (projectionKey, updateProps) {
        projectionEditor.updateSubject(projectionKey, updateProps);
        updateProjectionState();
    };
    var exportedProperties = {
        addProjectionItem: addProjectionItem,
        getOrderedProjectionList: getOrderedProjectionList,
        getProjectionItem: getProjectionItem,
        makeDefaultProjectionItem: makeDefaultProjectionItem,
        projectionEditor: projectionEditor,
        removeProjectionItem: removeProjectionItem,
        updateProjectionSubject: updateProjectionSubject,
    };
    return (0, jsx_runtime_1.jsx)(Context.Provider, __assign({ value: exportedProperties }, { children: children }), void 0);
};
// export default GQPProjectionContextProvider;
var ProjectionContext = {
    context: Context,
    Provider: ContextProvider,
};
exports.ProjectionContext = ProjectionContext;
//# sourceMappingURL=Provider.js.map