"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useProjectionUtilities = void 0;
/* eslint-disable import/prefer-default-export */
var react_1 = __importDefault(require("react"));
var context_1 = require("../context");
var useProjectionUtilities = function () {
    var _a = react_1.default.useContext(context_1.ProjectionContext.context), getOrderedProjectionList = _a.getOrderedProjectionList, makeDefaultProjectionItem = _a.makeDefaultProjectionItem, projectionEditor = _a.projectionEditor;
    return {
        getColumnOrderedProjectionDictionary: getOrderedProjectionList,
        getProjectableSubjectDictionary: function () {
            return projectionEditor.getProjectableSubjectsDictionary();
        },
        makeDefaultProjectionItem: makeDefaultProjectionItem,
        getProjectionAsJson: function () {
            return projectionEditor.toJson();
        },
    };
};
exports.useProjectionUtilities = useProjectionUtilities;
//# sourceMappingURL=useProjectionUtilities.js.map