import { CONSTS as PROJECTION_CONSTS } from "gabby-query-protocol-projection";
import { ProjectionContext } from "./Projections";
import type { TProjectionContextType } from "./Projections";
import { CONSTS as LIB_CONSTS } from "gabby-query-protocol-lib";
import type { TPredicateFormulaEditorContextType } from "./PredicateFormula";
import { PredicateFormulaEditorContextHooks, PredicateFormulaEditorContext } from "./PredicateFormula";
import * as opLabelsI18N from "./external-resources/operator-labels";
declare const GABBY_EXAMPLE_JSON_BLUE_SKIES: {
    LIB: {
        predicateSubjectsDictionaryJson: import("gabby-query-protocol-lib/dist/PredicateSubjects/type").TPredicateSubjectDictionaryJson;
        predicateTreeJson: import("gabby-query-protocol-lib/dist/Predicates").TSerializedPredicateTree;
    };
    PROJECTION: {
        projectableSubjectDictionaryJson: import("gabby-query-protocol-projection").TProjectableSubjectsDictionaryJson;
        projectionJson: import("gabby-query-protocol-projection").TProjectionProperties[];
    };
};
declare const GABBY_CONSTS: {
    LIB: typeof LIB_CONSTS;
    PROJECTION: typeof PROJECTION_CONSTS;
};
export { GABBY_EXAMPLE_JSON_BLUE_SKIES, GABBY_CONSTS, opLabelsI18N };
export declare const ProjectionContextHooks: {
    useProjectionSubjects: () => import("./Projections/hooks/useProjectionSubjects").IUseProjectionSubjects;
    useProjectionUtilities: () => import("./Projections/hooks/useProjectionUtilities").IUseProjectionUtilities;
};
export { PredicateFormulaEditorContext, PredicateFormulaEditorContextHooks, ProjectionContext, };
export type { TPredicateFormulaEditorContextType, TProjectionContextType };
export type { TPredicateOperatorLabels } from "./PredicateFormula";
